--- asterisk-1.6.1.1-orig/channels/chan_dahdi.c	2009-04-17 16:28:45.000000000 +0200
+++ asterisk-1.6.1.1/channels/chan_dahdi.c	2009-09-01 20:15:50.000000000 +0200
@@ -15122,16 +15122,6 @@
 
 	mwimonitornotify[0] = '\0';
 
-	v = ast_variable_browse(cfg, "channels");
-	if ((res = process_dahdi(&base_conf, "", v, reload, 0))) {
-		ast_mutex_unlock(&iflock);
-		ast_config_destroy(cfg);
-		if (ucfg) {
-			ast_config_destroy(ucfg);
-		}
-		return res;
-	}
-
 	/* Now get configuration from all normal sections in chan_dahdi.conf: */
 	for (cat = ast_category_browse(cfg, NULL); cat ; cat = ast_category_browse(cfg, cat)) {
 		/* [channels] and [trunkgroups] are used. Let's also reserve
@@ -15139,14 +15129,11 @@
 		 */
 		if (!strcasecmp(cat, "general") || 
 		    !strcasecmp(cat, "trunkgroups") ||
-		    !strcasecmp(cat, "globals") ||
-		    !strcasecmp(cat, "channels")) {
+		    !strcasecmp(cat, "globals")) {
 			continue;
 		}
-
-		memcpy(&conf, &base_conf, sizeof(conf));
-
-		if ((res = process_dahdi(&conf, cat, ast_variable_browse(cfg, cat), reload, PROC_DAHDI_OPT_NOCHAN))) {
+		
+		if ((res = process_dahdi(&base_conf, cat, ast_variable_browse(cfg, cat), reload, PROC_DAHDI_OPT_NOCHAN))) {
 			ast_mutex_unlock(&iflock);
 			ast_config_destroy(cfg);
 			if (ucfg) {
@@ -15156,6 +15143,19 @@
 		}
 	}
 
+	memcpy(&conf, &base_conf, sizeof(conf));
+
+	v = ast_variable_browse(cfg, "channels");
+	if ((res = process_dahdi(&conf, "", v, reload, 0))) {
+		ast_mutex_unlock(&iflock);
+		ast_config_destroy(cfg);
+		if (ucfg) {
+			ast_config_destroy(ucfg);
+		}
+		return res;
+	}
+
+	
 	ast_config_destroy(cfg);
 
 	if (ucfg) {
